# This file was created automatically by SWIG.
import anisoc
from oof2.SWIG.engine.property.elasticity.homogeneous import HomogeneousElasticityPtr
from oof2.SWIG.engine.property.elasticity.cijkl import CijklPtr
class AnisoElasticityPtr(HomogeneousElasticityPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,anisoc=anisoc):
        if self.thisown == 1 :
            anisoc.delete_AnisoElasticity(self)
    def crystal_cijkl(self, *_args, **_kwargs):
        val = apply(anisoc.AnisoElasticity_crystal_cijkl,(self,) + _args, _kwargs)
        if val: val = CijklPtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C AnisoElasticity instance at %s>" % (self.this,)
class AnisoElasticity(AnisoElasticityPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(anisoc.new_AnisoElasticity,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: aniso.spy,v $
# $Revision: 1.4 $
# $Author: langer $
# $Date: 2005/12/19 18:34:41 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Definitions of anisotropic elastic properties

from oof2.SWIG.engine.property.elasticity import cijkl
# Module cijkl has a name-collision with the cijkl parameter
# in the __init__, but both names make sense in their respective
# contexts, so locally alias cijkl module.
cijkl_module = cijkl

from oof2.common.IO import parameter
from oof2.engine import problem
from oof2.engine import propertyregistration 
from oof2.engine.IO import anisocijkl

PropertyRegistration = propertyregistration.PropertyRegistration

# CUBIC

class CubicElasticityProp(AnisoElasticity):
    def __init__(self, registration, name, cijkl):
        modulus = cijkl_module.Cijkl()
        # CubicElasticity's cijkl is a convertible parameter,
        # get it in base form before assigning.
        cbase = cijkl.to_base()
        modulus[0,0] = modulus[1,1] = modulus[2,2] = cbase.c11
        modulus[0,1] = modulus[0,2] = modulus[1,2] = cbase.c12
        modulus[3,3] = modulus[4,4] = modulus[5,5] = cbase.c44
        AnisoElasticity.__init__(self, registration, self, name,
                                 modulus)

PropertyRegistration(
    'Mechanical:Elasticity:Anisotropic:Cubic', CubicElasticityProp,
    "oof2.SWIG.engine.property.elasticity.aniso.aniso",11,
    [anisocijkl.CubicCijklParameter('cijkl',
                                    anisocijkl.CubicRank4TensorCij(c11=1.0,
                                                                   c12=0.5,
                                                                   c44=0.25),
                                    tip=parameter.emptyTipString)],
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
    tip="Cubic linear elasticity."
    )


# HEXAGONAL 

class HexagonalElasticityProp(AnisoElasticity):
    def __init__(self, registration, name, cijkl):
        modulus = cijkl_module.Cijkl()
        modulus[0,0] = modulus[1,1] = cijkl.c11
        modulus[2,2] = cijkl.c33
        modulus[0,1] = cijkl.c12
        modulus[0,2] = modulus[1,2] = cijkl.c13
        modulus[3,3] = modulus[4,4] = cijkl.c44
        modulus[5,5] = 0.5*(cijkl.c11 - cijkl.c12)
        AnisoElasticity.__init__(self, registration, self, name,
                                 modulus)

PropertyRegistration(
    'Mechanical:Elasticity:Anisotropic:Hexagonal',
    HexagonalElasticityProp,
    "oof2.SWIG.engine.property.elasticity.aniso.aniso",12,
    [anisocijkl.HexagonalCijklParameter(
    'cijkl', anisocijkl.HexagonalRank4TensorCij(c11=1.0,
                                            c12=0.5, c13=0.0,
                                                c33=0.0, c44=0.0),
    tip=parameter.emptyTipString)],
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
    tip="Hexagonal linear elasticity."
    )

# TETRAGONAL

class TetragonalElasticityProp(AnisoElasticity):
    def __init__(self, registration, name, cijkl):
        modulus = cijkl_module.Cijkl()
        modulus[0,0] = modulus[1,1] = cijkl.c11
        modulus[0,1] = cijkl.c12
        modulus[0,2] = modulus[1,2] = cijkl.c13
        modulus[2,2] = cijkl.c33
        modulus[3,3] = modulus[4,4] = cijkl.c44
        modulus[5,5] = cijkl.c66
        modulus[0,5] = cijkl.c16
        modulus[1,5] = -cijkl.c16
        AnisoElasticity.__init__(self, registration, self, name,
                                 modulus)

PropertyRegistration(
    'Mechanical:Elasticity:Anisotropic:Tetragonal',
    TetragonalElasticityProp,
    "oof2.SWIG.engine.property.elasticity.aniso.aniso",13,
    [anisocijkl.TetragonalCijklParameter(
    'cijkl', anisocijkl.TetragonalRank4TensorCij(
    c11=1.0, c12=0.5, c13=0.5, c33=1.0, c44=0.0, c66=0.0, c16=0.0),
    tip=parameter.emptyTipString)],
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
    tip="Tetragonal linear elasticity."
    )


# TRIGONAL-A

class TrigonalAElasticityProp(AnisoElasticity):
    def __init__(self, registration, name, cijkl):
        modulus = cijkl_module.Cijkl()
        modulus[0,0] = modulus[1,1] = cijkl.c11
        modulus[0,1] = cijkl.c12
        modulus[0,2] = modulus[1,2] = cijkl.c13
        modulus[2,2] = cijkl.c33
        modulus[3,3] = modulus[4,4] = cijkl.c44
        modulus[5,5] = 0.5*(cijkl.c11 - cijkl.c12)
        
        modulus[0,3] = cijkl.c14
        modulus[1,3] = -cijkl.c14
        modulus[4,5] = cijkl.c14
        
        modulus[0,4] = cijkl.c15
        modulus[1,4] = -cijkl.c15
        modulus[3,5] = -cijkl.c15
        AnisoElasticity.__init__(self, registration, self, name,
                                 modulus)

PropertyRegistration(
    'Mechanical:Elasticity:Anisotropic:TrigonalA',
    TrigonalAElasticityProp,
    "oof2.SWIG.engine.property.elasticity.aniso.aniso",14,
    [anisocijkl.TrigonalACijklParameter('cijkl',
                                        anisocijkl.TrigonalARank4TensorCij(
    c11=1.0, c12=0.5, c13=0.5, c33=1.0, c44=0.25, c14=0.0, c15=0.0),
                                        tip=parameter.emptyTipString)],
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
    tip="Trigonal-A linear elasticity.")


# TRIGONAL-B

class TrigonalBElasticityProp(AnisoElasticity):
    def __init__(self, registration, name, cijkl):
        modulus = cijkl_module.Cijkl()
        modulus[0,0] = modulus[1,1] = cijkl.c11
        modulus[0,1] = cijkl.c12
        modulus[0,2] = modulus[1,2] = cijkl.c13
        modulus[2,2] = cijkl.c33
        modulus[3,3] = modulus[4,4] = cijkl.c44
        modulus[5,5] = 0.5*(cijkl.c11 - cijkl.c12)

        modulus[0,3] = cijkl.c14
        modulus[1,3] = -cijkl.c14
        modulus[4,5] = cijkl.c14
        AnisoElasticity.__init__(self, registration, self, name,
                                 modulus)

PropertyRegistration('Mechanical:Elasticity:Anisotropic:TrigonalB',
                     TrigonalBElasticityProp,
                     "oof2.SWIG.engine.property.elasticity.aniso.aniso",15,
                     [anisocijkl.TrigonalBCijklParameter(
    'cijkl', anisocijkl.TrigonalBRank4TensorCij(
    c11=1.0, c12=0.5,c13=0.5,c33=1.0,c44=0.25,c14=0.0),
    tip=parameter.emptyTipString)],
    fields=[problem.Displacement], fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
                     tip="Trigonal-B linear elasticity.")


# ORTHORHOMBIC

class OrthorhombicElasticityProp(AnisoElasticity):
    def __init__(self, registration, name, cijkl):
        modulus = cijkl_module.Cijkl()
        modulus[0, 0] = cijkl.c11
        modulus[0, 1] = cijkl.c12
        modulus[0, 2] = cijkl.c13
        modulus[1, 1] = cijkl.c22
        modulus[1, 2] = cijkl.c23
        modulus[2, 2] = cijkl.c33
        modulus[3, 3] = cijkl.c44
        modulus[4, 4] = cijkl.c55
        modulus[5, 5] = cijkl.c66
        AnisoElasticity.__init__(self, registration, self, name,
                                 modulus)

PropertyRegistration(
    'Mechanical:Elasticity:Anisotropic:Orthorhombic',
    OrthorhombicElasticityProp,
    "oof2.SWIG.engine.property.elasticity.aniso.aniso",16,
    [anisocijkl.OrthorhombicCijklParameter(
    'cijkl',
    anisocijkl.OrthorhombicRank4TensorCij(c11=1.0, c12=0.5, c13=0.5,
                                      c22=1.0, c23=0.5, c33=1.0,
                                      c44=0.25, c55=0.25, c66=0.25),
    tip=parameter.emptyTipString)],
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
    tip="Orthorhombic linear elasticity.")

# MONOCLINIC

class MonoclinicElasticityProp(AnisoElasticity):
    def __init__(self, registration, name, cijkl):
        modulus = cijkl_module.Cijkl()
        modulus[0, 0] = cijkl.c11
        modulus[0, 1] = cijkl.c12
        modulus[0, 2] = cijkl.c13
        modulus[0, 4] = cijkl.c15
        modulus[1, 1] = cijkl.c22
        modulus[1, 2] = cijkl.c23
        modulus[1, 4] = cijkl.c25
        modulus[2, 2] = cijkl.c33
        modulus[2, 4] = cijkl.c35
        modulus[3, 3] = cijkl.c44
        modulus[3, 5] = cijkl.c46
        modulus[4, 4] = cijkl.c55
        modulus[5, 5] = cijkl.c66
        AnisoElasticity.__init__(self, registration, self, name,
                                 modulus)

PropertyRegistration(
    'Mechanical:Elasticity:Anisotropic:Monoclinic',
    MonoclinicElasticityProp,
    "oof2.SWIG.engine.property.elasticity.aniso.aniso",17,
    [anisocijkl.MonoclinicCijklParameter(
    'cijkl',
    anisocijkl.MonoclinicRank4TensorCij(c11=1.0, c12=0.5, c13=0.5, c15=0.0,
                                        c22=1.0, c23=0.5, c25=0.0,
                                        c33=0.25, c35=0.0, c44=0.25,
                                        c46=0.0, c55=0.25, c66=0.25),
    tip=parameter.emptyTipString)],
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
    tip="Monoclinic linear elasticity.")


# TRICLINIC

class TriclinicElasticityProp(AnisoElasticity):
    def __init__(self, registration, name, cijkl):
        modulus = cijkl_module.Cijkl()
        modulus[0,0] = cijkl.c11
        modulus[0,1] = cijkl.c12
        modulus[0,2] = cijkl.c13
        modulus[0,3] = cijkl.c14
        modulus[0,4] = cijkl.c15
        modulus[0,5] = cijkl.c16

        modulus[1,1] = cijkl.c22
        modulus[1,2] = cijkl.c23
        modulus[1,3] = cijkl.c24
        modulus[1,4] = cijkl.c25
        modulus[1,5] = cijkl.c26

        modulus[2,2] = cijkl.c33
        modulus[2,3] = cijkl.c34
        modulus[2,4] = cijkl.c35
        modulus[2,5] = cijkl.c36

        modulus[3,3] = cijkl.c44
        modulus[3,4] = cijkl.c45
        modulus[3,5] = cijkl.c46

        modulus[4,4] = cijkl.c55
        modulus[4,5] = cijkl.c56

        modulus[5,5] = cijkl.c66
        AnisoElasticity.__init__(self, registration, self, name,
                                 modulus)
    
PropertyRegistration(
    'Mechanical:Elasticity:Anisotropic:Triclinic',
    TriclinicElasticityProp,
    "oof2.SWIG.engine.property.elasticity.aniso.aniso",18,
    [anisocijkl.TriclinicCijklParameter(
    'cijkl',
    anisocijkl.TriclinicRank4TensorCij(c11=1.0, c12=0.5, c13=0.5, c14=0.0,
                                   c15=0.0, c16=0.0, c22=1.0, c23=0.5,
                                   c24=0.0, c25=0.0, c26=0.0, c33=1.0,
                                   c34=0.0, c35=0.0, c36=0.0, c44=0.25,
                                   c45=0.0, c46=0.0, c55=0.25, c56=0.0,
                                   c66=0.25),
    tip=parameter.emptyTipString)],
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
    tip="Triclinic linear elasticity.")
