// -*- C++ -*-
// $RCSfile: massdensity.C,v $
// $Revision: 1.25 $
// $Author: reida $
// $Date: 2006/01/27 21:30:14 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>
#include "common/coord.h"
#include "massdensity.h"
#include "engine/element.h"
#include "engine/elementnodeiterator.h"
#include "engine/field.h"
#include "engine/flux.h"
#include "engine/indextypes.h"
#include "engine/material.h"
#include "engine/femesh.h"
#include "common/space.h"
#include "common/trace.h"
#include "common/ooferror.h"

MassDensityProp::MassDensityProp(PyObject *reg, const std::string &nm,
				 double rho)
  : ScalarTimeDerivPrefactor(nm,reg, rho)
{
  displacement = dynamic_cast<TwoVectorField*>(Field::getField("Displacement"));
  stress_flux = dynamic_cast<SymmetricTensorFlux*>(Flux::getFlux("Stress"));
}

int MassDensityProp::integration_order(const FEMesh*, const Element*) const {
  return 0;
}

