// -*- C++ -*-
// $RCSfile: subproblem.h,v $
// $Revision: 1.6 $
// $Author: redwing $
// $Date: 2005/06/16 15:20:49 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>
#ifndef SUBPROBLEM_H
#define SUBPROBLEM_H
#include <vector>
#include "matvec.h"
class FEMesh;

class SubProblem {
private:
  std::vector<int> * freedofmap;
  std::vector<int> * forward_mapping;
  VECTOR_D * x_prev;/*
		      Solution from the previous step.
		      Will be restored if step adapter manager fails
		    */
public:
  SubProblem() : freedofmap(0), forward_mapping(0), x_prev(0) {}
  virtual ~SubProblem();
  //
  void set_freedofmap(const FEMesh *femesh); //makes a copy of fredofmap
  const std::vector<int> * get_freedofmap() {return freedofmap;} 
  //
  void set_forward_mapping(const std::vector<int> * fmapping); //makes a copy
  const std::vector<int> * get_forward_mapping() {return forward_mapping;}

  VECTOR_D * get_prev_solution() {return x_prev;}
  void set_prev_solution( VECTOR_D *);
};

#endif // SUBPROBLEM_H
